
Smart Proxy - Bug #14142

Race condition on all? versions of rack when smart-proxy is configured with both http and https. 

03/10/2016 10:25 AM - Anonymous

Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Core   

Target version: 1.11.1   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/smart-pro

xy/pull/397

  

Description

An issue in rack around here: https://github.com/rack/rack/blob/master/lib/rack/handler/webrick.rb#L31. A singleton-class variable is

being initialized at that spot. It is possible that if more than one call to Rack::Handler::WebRick.run are made sufficiently close to

each other, then @server variable is re-initialized with a value from a latter call.

Associated revisions

Revision e5b66974 - 03/23/2016 08:15 AM - Dominic Cleal

fixes #14142 - launch WEBrick directly, avoiding Rack::Server

Rack::Server calls server-specific handlers such as

Rack::Handler::WEBrick which relies on a class-level variable that

causes race conditions when launching two WEBrick instances via

Rack::Server within the same process.

Launching WEBrick with the Rack::Builder-prepared app prevents the race

between the two instances, ensuring both start up correctly.  The Rack

WEBrick handler is still used to interface between WEBrick and the app

built with Rack.

History

#1 - 03/17/2016 08:21 AM - Dominic Cleal

I think I'm seeing this issue too, with the symptom being that one of the two servers doesn't get configured correctly.  e.g. https_port is 8442, while

http_port is 8443 for me, and occasionally I see:

I, [2016-03-17T12:19:14.251516 #20461]  INFO -- : WEBrick::HTTPServer#start: pid=20461 port=8442

I, [2016-03-17T12:19:14.251690 #20461]  INFO -- : WEBrick::HTTPServer#start: pid=20461 port=8442

 The server doesn't respond at all on port 8443 when this happens.

#2 - 03/18/2016 08:20 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Anonymous

- Pull request https://github.com/theforeman/smart-proxy/pull/396 added

#3 - 03/21/2016 10:34 AM - The Foreman Bot

- Pull request https://github.com/theforeman/smart-proxy/pull/397 added

#4 - 03/22/2016 04:22 AM - Dominic Cleal

- Assignee changed from Anonymous to Dominic Cleal

- Pull request deleted (https://github.com/theforeman/smart-proxy/pull/396)

#5 - 03/23/2016 09:01 AM - Dominic Cleal
https://github.com/rack/rack/blob/master/lib/rack/handler/webrick.rb#L31


- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset e5b669742356ea78974d0e74425704d1c48ad0b9.

#6 - 03/24/2016 08:06 AM - Dominic Cleal

- translation missing: en.field_release set to 141
